
#include "MacroPatternMatch.h"

#include "HROOTHistTH1.h"

#include "HROOTCoreTArrayD.h"

#include "TH1D.h"

#include "HROOTHistTH1D.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TH1_DEF_VIRT(TH1D)
TARRAYD_DEF_VIRT(TH1D)
TNAMED_DEF_VIRT(TH1D)
TATTLINE_DEF_VIRT(TH1D)
TATTFILL_DEF_VIRT(TH1D)
TATTMARKER_DEF_VIRT(TH1D)
TOBJECT_DEF_VIRT(TH1D)
DELETABLE_DEF_VIRT(TH1D)
TARRAY_DEF_VIRT(TH1D)
TH1D_DEF_VIRT(TH1D)
TH1D_DEF_NONVIRT(TH1D)
TH1D_DEF_ACCESSOR(TH1D)

