
#ifdef __cplusplus
extern "C" {
#endif

#pragma once


#include "HROOT-histType.h"

#include "HROOTHistTH2.h"

#include "HROOTCoreTArrayD.h"

#include "HROOTHistTH1.h"

#include "HROOTCoreTNamed.h"

#include "HROOTCoreTAttLine.h"

#include "HROOTCoreTAttFill.h"

#include "HROOTCoreTAttMarker.h"

#include "HROOTCoreTObject.h"

#include "STDDeletable.h"

#include "HROOTCoreTArray.h"

#include "HROOT-coreType.h"


#define TH2D_DECL_VIRT(Type) \



#define TH2D_DECL_NONVIRT(Type) \
Type##_p Type##_newTH2D ( const char* name, const char* title, int nbinsx, double xlow, double xup, int nbinsy, double ylow, double yup );


#define TH2D_DECL_ACCESSOR(Type) \



#define TH2D_DEF_VIRT(Type) \



#define TH2D_DEF_NONVIRT(Type) \
Type##_p Type##_newTH2D ( const char* name, const char* title, int nbinsx, double xlow, double xup, int nbinsy, double ylow, double yup ) {\
Type* newp=new Type(name, title, nbinsx, xlow, xup, nbinsy, ylow, yup);return from_nonconst_to_nonconst<Type##_t, Type>(newp);\
}


#define TH2D_DEF_ACCESSOR(Type) \



TH2_DECL_VIRT(TH2D)
TARRAYD_DECL_VIRT(TH2D)
TH1_DECL_VIRT(TH2D)
TNAMED_DECL_VIRT(TH2D)
TATTLINE_DECL_VIRT(TH2D)
TATTFILL_DECL_VIRT(TH2D)
TATTMARKER_DECL_VIRT(TH2D)
TOBJECT_DECL_VIRT(TH2D)
DELETABLE_DECL_VIRT(TH2D)
TARRAY_DECL_VIRT(TH2D)
TH2D_DECL_VIRT(TH2D)
TH2D_DECL_NONVIRT(TH2D)
TH2D_DECL_ACCESSOR(TH2D)

#ifdef __cplusplus
}
#endif

